#ifndef  __DJSTOP_H_
#define  __DJSTOP_H_

#include <signal.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/socket.h>
#include <fcntl.h>
#include <time.h>
#include <netdb.h>
#include <net/ethernet.h>
#include <netinet/ip.h>
#include <netinet/in.h>
#include <netinet/tcp.h>
#include <netinet/ip_icmp.h>
#include <arpa/inet.h>
#include <pcap.h>   // libpcap  ȭ
#include <pthread.h>

#define	 	PROMISCUOUS 		1
#define		IP_FORWARD_PATH		"/proc/sys/net/ipv4/ip_forward"
// HASH TABLE 
#define	 	HASH_TABLE_SIZE		19		
#define  	PROGRAM_TYPE 		2

#define		FTP_DATA			20
#define		FTP_CONTROL			21
#define		TELNET				23
#define		SMTP				25
#define		HTTP				80
#define		POP3				110
#define		NNTP				119

FILE	*site_fp, *program_fp, *backdoor_fp;
int		schedule[7][24];
int		datalink;	// datalink type
char	ip_forward_origin;	
pcap_t *pd;
int  pflag;         // pop3 ´(ϼ)
int  sflag;         // smtp ´(ϼ۽)
int  tflag;         //  ͳ  ߴ
int  mflag;         // ǽð ͸
int  cflag;         // ܸ ϱ             
int  lflag;         // ϸ ϱ            
int  aflag;         // Ѵ ϱ               
int  xflag;         //  port   tcp service                
int  wflag;         // Switching ȯ Ѵ.

//  Ʈ 
typedef struct site_list *PSITE;
struct site_list {
	u_int32_t		ip_addr;
	char			domain_name[50];
	PSITE			next;
};
PSITE psite_hash[HASH_TABLE_SIZE];		//  Ʈ ؽ ̺

//  α׷ 
typedef struct port_list *PPORT;
struct port_list {
	char			name[50];
	u_short			port_number;
	PPORT			next;
};
PPORT	pport_hash[HASH_TABLE_SIZE];		//  α׷ ؽ ̺

//  
typedef struct cont_list *PCONT;
struct cont_list {
	char			class[30];
	u_int32_t		ip_addr;
	char			hw_addr[25];
	char			name[20];
	PCONT			next;
};
PCONT	pcont_hash[HASH_TABLE_SIZE];		//  ؽ ̺

// ip upper layer 4 bytes
// tcp udp   4 bytes source port destination port .
struct u_layer_hdr {
	u_short			source;
	u_short			dest;
};

typedef struct {
	pthread_t	tid;
	long		packet_capture_count;
	long		intercept_count;
} Thread;
Thread *tptr;

void send_icmp(int, struct iphdr *, struct u_layer_hdr *);
void *packet_loop(void *);
void check_packet(int, char *, int);
void insert_site_log(char *, char *, char *, char *, char *);
void insert_program_log(u_short, char *, char *, char *, char *);
void insert_backdoor_log(u_short, char *, char *, char *, char *, char *);
void sig_int(int);
void sig_alarm(int);
int load_site_list(void);
int load_port_list(void);
int load_cont_list(void);
void init_scheduling(void);
void set_ip_forward(int);

#endif		/*  __DJSTOP_H  */
