#include "djstop.h"

//  ȣƮ ؽ ̺ ϴ Լ
void insert_cont_list(char *class, char *name, char *ip_addr)
{
	PCONT	new_node, temp;
	int		bucket_num;

	// ο 带  ޸ Ҵ
	if( !(new_node=(PCONT)malloc(sizeof(struct cont_list))) ) { 
    	fprintf(stderr, "Malloc fail!\n");
		return;
    }
	// ο 忡 ʵ尪 Է 	
	strncpy(new_node->class, class, strlen(class));
	new_node->ip_addr = inet_addr(ip_addr);
	strncpy(new_node->name, name, strlen(name));
	new_node->next = NULL;
	
	// hash  ϱ
	bucket_num =  new_node->ip_addr * 3 % HASH_TABLE_SIZE; 

	// ش     
	if ( pcont_hash[bucket_num] == NULL) {
	    pcont_hash[bucket_num] = new_node;	//  ̴.
	} else {
	    temp = pcont_hash[bucket_num];		// ̹ ٸ 尡 ϹǷ Ʈ Ѿư.
	    for(;;) {
			if(temp->next != NULL) {
		    	temp = temp->next;			//    尡 ƴϴ.
			}
			else {
		    	temp->next = new_node;		//  ̹Ƿ next   带 Ʈϰ ȴ. 
		    	break;
			}
	    }
	}
}

int load_cont_list(void)
{
	FILE	*fp;
	char 	buffer[80];
	char	class[30], name[20], cont_ip[16];
#if (__DEBUG)
	int		i;
	PCONT	temp;
#endif /* __DEBUG */
	
    if((fp = fopen("cont_list.dat","r")) == NULL) {
		fprintf(stdout, "Can't open schedule file\n");
		exit(1);
    }

	while(fgets(buffer, 80, fp) != NULL) {
		if ( buffer[0] != '#' )	{			// ּ line skip
    	    sscanf(buffer, "%30s %20s %18s", class, name, cont_ip);
	   	   	insert_cont_list(class, name, cont_ip);
		}
	}

#if (__DEBUG)
	// http_list test 
	for (i=0; i<HASH_TABLE_SIZE; i++) {
		if ( pcont_hash[i] != NULL ) {
			temp = pcont_hash[i];
			do {
				fprintf(stdout,"%s %s %s\n", temp->class, temp->name, inet_ntoa(temp->ip_addr));
				temp = temp->next;
			} while ( temp != NULL) ;
		}
	}
#endif
	return (1);
}

//  α׷ ؽ ̺ ϴ Լ
void insert_port_list(char *name, u_short port_number)
{
	PPORT	new_node, temp;
	int		bucket_num;

	if( !(new_node=(PPORT)malloc(sizeof(struct port_list))) ) { 
    		fprintf(stderr, "Malloc fail!\n");
		return;
    }

	strncpy(new_node->name, name, strlen(name));
	new_node->port_number= port_number;
	new_node->next = NULL;
	
	bucket_num =  new_node->port_number * 3 % HASH_TABLE_SIZE; 

	if ( pport_hash[bucket_num] == NULL) {
	    pport_hash[bucket_num] = new_node;	
	} else {
	    temp = pport_hash[bucket_num];
	    for(;;) {
			if(temp->next != NULL) {
		    	temp = temp->next;
			}
			else {
		    	temp->next = new_node;
		    	break;
			}
	    }
	}
}

int load_port_list(void)
{
	FILE    *fp;
	char	buffer[80];
	char    name[50];
	u_short port_number;
#if (__DEBUG)
	int		i;
	PPORT	temp;
#endif /* __DEBUG */
	
	if ( xflag == 1 ) {
    	if((fp = fopen("port_list.allow","r")) == NULL) {
			fprintf(stdout, "Can't open port_number list file\n");
			exit(1);
		}
    } else {
    	if((fp = fopen("port_list.dat","r")) == NULL) {
			fprintf(stdout, "Can't open port_number list file\n");
			exit(1);
    	}
	}

	while(fgets(buffer, 80, fp) != NULL) {
		if ( buffer[0] != '#' )	{			// ּ line skip
			sscanf(buffer,"%50s %hu", name, &port_number);
	    	insert_port_list(name, port_number);
		}
	}
    
#if (__DEBUG) 
	// http_list test 
	for (i=0; i<HASH_TABLE_SIZE; i++) {
		if ( pport_hash[i] != NULL ) {
			temp = pport_hash[i];
			do {
				fprintf(stdout,"%s %hu\n", temp->name, temp->port_number);
				temp = temp->next;
			} while ( temp != NULL) ;
		}
	}
#endif
	return (1);
}

//  Ʈ ؽ ̺ ϴ Լ
void insert_site_list(u_char *domain_name, char *ip_addr)
{
	PSITE	new_node, temp;
	int		bucket_num;

	if( !(new_node=(PSITE)malloc(sizeof(struct site_list))) ) { 
    		fprintf(stderr, "Malloc fail!\n");
		return;
    }

	new_node->ip_addr = inet_addr(ip_addr);
	strncpy(new_node->domain_name, domain_name, strlen(domain_name));
	new_node->next = NULL;
	
	bucket_num =  new_node->ip_addr * 3 % HASH_TABLE_SIZE; 
	if ( psite_hash[bucket_num] == NULL) {
	    psite_hash[bucket_num] = new_node;
	} else {
	    temp = psite_hash[bucket_num];
	    for(;;) {
			if(temp->next != NULL) {
		    	temp = temp->next;
			}
			else {
		    	temp->next = new_node;
		    	break;
			}
	    }
	}
}

int load_site_list(void)
{
	FILE *fp;
	char buffer[80];
	char domain[50], ip_addr[16];
#if (__DEBUG)
	int		i;
	PSITE	temp;
#endif /* __DEBUG */

    if((fp = fopen("site_list.dat","r")) == NULL) {
		fprintf(stdout, "Can't open schedule file\n");
		exit(1);
    }

	while(fgets(buffer, 80, fp) != NULL) {
		if ( buffer[0] != '#' )	{			// ּ line skip
			sscanf(buffer,"%50s %16s", domain, ip_addr);
	        insert_site_list(domain, ip_addr);
		}
	}
    
#if (__DEBUG) 
	// http_list test 
	for (i=0; i<HASH_TABLE_SIZE; i++) {
		if ( psite_hash[i] != NULL ) {
			temp = psite_hash[i];
			do {
				fprintf(stdout,"%s %s\n", inet_ntoa(temp->ip_addr), temp->domain_name);
				temp = temp->next;
			} while ( temp != NULL) ;
		}
	}
#endif
	return (1);
}
