/* --------------------------------------------------
   icmp packet    Լ
   -------------------------------------------------*/
#include "djstop.h"

unsigned short in_cksum(unsigned short *addr, int len)
{
    register int     nleft = len;
    register int     sum = 0;
    unsigned short *w = addr;
    unsigned short answer = 0;
    
    while (nleft > 1) {
	   sum += *w++;
	      nleft -=2;
    }
    
    if (nleft == 1) {
	   *(unsigned char *) (&answer) = *(unsigned char *) w;
	      sum += answer;
    }
    
    sum = (sum >> 16) + (sum & 0xffff);
    sum += (sum >> 16);
    answer = ~sum;
    return (answer);
}

void send_icmp(int sockfd, struct iphdr *iph, struct u_layer_hdr *upperh)
{
	char buff[76];    // icmp packet  üκ
	char data[68];    //icmp data κ ip header + ulp header:8bytes
	int len;
	struct sockaddr send;
	struct icmp *icmp;
	struct sockaddr_in *willsend;
	
	willsend = (struct sockaddr_in *) &send;
   	willsend->sin_family = AF_INET;
   	willsend->sin_addr.s_addr = iph->saddr;
		
	icmp = (struct icmp *) buff;
	// Protocol unreachable : ICMP type
	// /usr/include/netinet/ip_icmp.h 
   	icmp->icmp_type = ICMP_DEST_UNREACH;	// 3 
   	icmp->icmp_code = ICMP_PROT_UNREACH;	// 2
   	icmp->icmp_id = 0;
   	icmp->icmp_seq = 0;

	// icmp data κ߿ ߸ Ŷ ip header
   	memcpy(data, iph, iph->ihl*4);
	// icmp data κ߿ ߸ Ŷ Upper Layer Protocol  8 bytes
   	memcpy(data + iph->ihl*4, upperh, 8);
	// dataκ icmp_dataκп 
   	memcpy(icmp->icmp_data, data, iph->ihl*4+8);
	//   icmp packet 
   	len = (iph->ihl*4) + 8 + 8;
	// icmp checksum field 
   	icmp->icmp_cksum= 0;
   	icmp->icmp_cksum= in_cksum((u_short *) icmp, len);
	// ϼ ICMP packet 

   	sendto(sockfd, buff, len, 0, &send, sizeof(send)); 
}
