/*  α׷ key  ߰ϱ  ش α׷ ϴ ip address
 *  Ʈ ȣ  ִ α׷									*/

#include <sys/time.h>
#include <netinet/in.h>
#include <net/ethernet.h>
#include <pcap.h>
#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <unistd.h>
#include <netinet/ip.h>
#include <netinet/tcp.h>
#include <netinet/udp.h>
#include <netinet/ip_icmp.h>
#include <arpa/inet.h>

#define	 PROMISCUOUS 1

struct  iphdr  *iph;
struct  tcphdr  *tcph;
struct  udphdr  *udph;
static	pcap_t *pd;
const unsigned char *packetp;
const unsigned char *snapend;
int sockfd;
int count;
void packet_analysis(unsigned char *, const struct pcap_pkthdr *, const unsigned char *);

struct printer {
   pcap_handler f;
   int type;
};
   
/* datalink type  Ҹ Լ 
   ϵ  ü                */
static struct printer printers[] = {
   { packet_analysis, DLT_IEEE802 },
   { packet_analysis, DLT_EN10MB  },
   { NULL, 0 },
};
   
/*  datalink type   Լ ϰ ȴ.
    ̴ pcap_handler Լ   Եȴ. */
static pcap_handler lookup_printer(int type) 
{
	struct printer *p;
    
	for(p=printers; p->f; ++p)
   	if(type == p->type)
		return p->f;
	perror("unknown data link type");
	return NULL;
}

/* pcap_loop()  Ŷ   ҷ Լ
   pcap_handler  Լ ϰ ֱ ̴ */
void packet_analysis(unsigned char *user, const struct pcap_pkthdr *h, 
                    const unsigned char *p)
{
	int port;
	unsigned int caplen = h->caplen;
	unsigned int length = h->len;
	struct ether_header *ep;
	struct in_addr d_addr;
	unsigned short ether_type;
	unsigned short extracted_ethertype;
	unsigned char *tcpdata, *udpdata;
	register const unsigned short *sp;
	register unsigned int i;
	register int nshorts;

	packetp = p;
	snapend = p + caplen;
		
	length -= sizeof(struct ether_header);
	caplen -= sizeof(struct ether_header);
	
	ep = (struct ether_header *)p;
	p += sizeof(struct ether_header);
	ether_type = ntohs(ep->ether_type);
	
	// lan frame IEEE802ΰ ether_typeʵ尡 ʵ尡 ȴ.
	if(ether_type <= 1500) {
	    ;
	}
	else 
	{    
	    extracted_ethertype = 0;
	    iph = (struct iphdr *) p;
	    sp = (unsigned short *)p;
	    nshorts = (unsigned int) length / sizeof(unsigned short);
	    i = 0;
	    if (ntohs(ep->ether_type) == ETHERTYPE_IP) {
		// packet capturing  ȭ鿡 ϴ κ
//		fprintf(stdout,"\tIP Address => %s\n", inet_ntoa(iph->daddr));

		/* packet ipκ   20bytes ǳʶ 
   		tcp header  ȴ.                            */
		d_addr.s_addr = iph->daddr;
		if(iph->protocol == IPPROTO_TCP) {
		        tcph = (struct tcphdr *) (p + iph->ihl * 4);
		        tcpdata = (unsigned char *) (p + iph->ihl*4) + 20;
			port = ntohs(tcph->dest); 
			if ( port > 1024 ) {
			    fprintf(stdout,"<<count => %d>>\n",++count);
	    		fprintf(stdout,"\tIP Address => %s\n", inet_ntoa(d_addr));
			    fprintf(stdout, "\tPort => %d\n\n", port);
			}
	    }
		else if(iph->protocol == IPPROTO_UDP) {
	    	    udph = (struct udphdr *) (p + iph->ihl * 4);
		    udpdata = (unsigned char *) (p + iph->ihl*4) + 8;
		    port = ntohs(udph->dest); 
		    if ( port > 1024 ) {
			fprintf(stdout,"<<count => %d>>\n",++count);
	    		fprintf(stdout,"\tIP Address => %s\n", inet_ntoa(d_addr));
		        fprintf(stdout,"\tPort => %d\n\n", port);
		    }
		}
	    }	
	}
}

void sig_int(int sig)
{
    printf("Bye!!\n");
    pcap_close(pd);
    close(sockfd);
    exit(0);
}

void usage(void)
{
    fprintf(stdout," Usage : extract_key ip_address\n");
}

int main(int argc, char *argv[])
{
	struct	bpf_program fcode;
	pcap_handler printer = NULL;
	char	*device, *filter_rule;
	char    temp_filter[28]="ip src host ";
	char	ebuf[PCAP_ERRBUF_SIZE];
	int	 i, snaplen = 68, packetcnt = 0;
	bpf_u_int32 localnet, netmask;
	unsigned char	*pcap_userdata;
	
	if( (argc-1 < 1) || (argc-1) > 1) {
	    usage(); 
	    exit(1);
	}

	if ( strlen(argv[1]) > 15 ) {
		fprintf(stderr,"Inappropriate address for %s\n", argv[0]);
		exit(0);
	}
	
	// ip src host ip_address  filter rule .
	strcat(temp_filter, argv[1]);
	filter_rule = temp_filter;
	
	signal(SIGINT,sig_int);
	
	device = pcap_lookupdev(ebuf);
	if(device == NULL) {
   		perror(ebuf);           
   		exit(1);
   	}
	
	pd = pcap_open_live(device, snaplen, PROMISCUOUS, 1000, ebuf);
	if(pd == NULL) {
   		perror(ebuf);          
   		exit(1);
   	}
	
	i = pcap_snapshot(pd);
	if(snaplen < i) {
   		perror(ebuf);                            
  		exit(1);
   	}
	
	if(pcap_lookupnet(device, &localnet, &netmask, ebuf) < 0) {
   		perror(ebuf);
   		exit(1);
   	}
	
	setuid(getuid());
	
	if(pcap_compile(pd, &fcode, filter_rule, 0, netmask) < 0) {
   		perror(ebuf);
   	exit(1);
   	}
	
	if(pcap_setfilter(pd, &fcode) < 0) {
   		perror(ebuf);
   	exit(1);
   	}
	
	fflush(stderr);
	
	printer = lookup_printer(pcap_datalink(pd));
	pcap_userdata = 0;
	
	if(pcap_loop(pd, packetcnt, printer, pcap_userdata) < 0) {
   		perror("pcap_loop error");
   	exit(1);
   	}
	
	pcap_close(pd);
	exit(0);
}
